Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr.instruct
Class FixedAttribute

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.instruct.Instruction
              net.sf.saxon.expr.instruct.SimpleNodeConstructor
                  net.sf.saxon.expr.instruct.AttributeCreator
                      net.sf.saxon.expr.instruct.FixedAttribute

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, ValidatingInstruction, InstructionInfo, Locator

    public final class FixedAttribute

extends AttributeCreator

An instruction derived from an xsl:attribute element in stylesheet, or from an attribute constructor in XQuery. This version deals only with attributes whose name is known at compile time. It is also used for attributes of literal result elements. The value of the attribute is in general computed at run-time.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor
`select`

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`FixedAttribute(NodeName nodeName, int validationAction, SimpleType schemaType)` Construct an Attribute instruction

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`Expression` | `copy()` Copy an expression.
`NodeInfo` | `evaluateItem(XPathContext context)` Evaluate as an expression.
`NodeName` | `evaluateNodeName(XPathContext context)` Run-time method to compute the name of the node being constructed.
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`NodeName` | `getAttributeName()`
`int` | `getAttributeNameCode()` Get the name pool name code of the attribute to be constructed
`int` | `getCardinality()` Determine the static cardinality of the expression.
`int` | `getInstructionNameCode()` Get the name of this instruction (return 'xsl:attribute')
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
`void` | `localTypeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Method to perform type-checking specific to the kind of instruction
`void` | `setSelect(Expression select, Configuration config)` Set the expression defining the value of the attribute.

Methods inherited from class net.sf.saxon.expr.instruct.AttributeCreator
`computeSpecialProperties, getOptions, getSchemaType, getValidationAction, processValue, setNoSpecialChars, setOptions, setRejectDuplicates, setSchemaType, setValidationAction`

Methods inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor
`checkContent, computeCardinality, createsNewNodes, getContentExpression, iterate, iterateSubExpressions, optimize, processLeavingTail, promoteInst, replaceSubExpression, simplify, typeCheck`

Methods inherited from class net.sf.saxon.expr.instruct.Instruction
`assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getImplementationMethod, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toString, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### FixedAttribute

    public FixedAttribute(NodeName nodeName,
                          int validationAction,
                          SimpleType schemaType)

  Construct an Attribute instruction

  Parameters:
    `nodeName` - Represents the attribute name
    `validationAction` - the validation required, for example strict or lax
    `schemaType` - the schema type against which validation is required, null if not applicable of the instruction - zero if the attribute was not present

Method Detail

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction (return 'xsl:attribute')

  Overrides:
    `getInstructionNameCode` in class `Instruction`
  Returns:
    a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

### getAttributeName

    public NodeName getAttributeName()

### setSelect

    public void setSelect(Expression select,
                          Configuration config)

  Set the expression defining the value of the attribute. If this is a constant, and if validation against a schema type was requested, the validation is done immediately.

  Overrides:
    `setSelect` in class `SimpleNodeConstructor`
  Parameters:
    `select` - The expression defining the content of the attribute
    `config` - The Saxon configuration

### localTypeCheck

    public void localTypeCheck(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Description copied from class: `SimpleNodeConstructor`
  Method to perform type-checking specific to the kind of instruction

  Specified by:
    `localTypeCheck` in class `SimpleNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of the context item
  Throws:
    `XPathException` - if a type error is detected

### getAttributeNameCode

    public int getAttributeNameCode()

  Get the name pool name code of the attribute to be constructed

  Returns:
    the attribute's name code

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Description copied from class: `Instruction`
  Get the item type of the items returned by evaluating this instruction

  Overrides:
    `getItemType` in class `Instruction`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Description copied from class: `Expression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Overrides:
    `getCardinality` in class `Expression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### evaluateNodeName

    public NodeName evaluateNodeName(XPathContext context)

  Description copied from class: `SimpleNodeConstructor`
  Run-time method to compute the name of the node being constructed. This is overridden for nodes that have a name. The default implementation returns -1, which is suitable for unnamed nodes such as comments

  Overrides:
    `evaluateNodeName` in class `SimpleNodeConstructor`
  Parameters:
    `context` - the XPath dynamic evaluation context
  Returns:
    the name pool nameCode identifying the name of the constructed node

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Parameters:
    `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
    `env` - the static context
    `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
  Throws:
    `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

### evaluateItem

    public NodeInfo evaluateItem(XPathContext context)
                          throws XPathException

  Description copied from class: `SimpleNodeConstructor`
  Evaluate as an expression.

  Overrides:
    `evaluateItem` in class `SimpleNodeConstructor`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.